(* ICFP Programming Contest 2001
 * Copyright (C) 2001 Jean-Christophe Filliatre *)

(*s This module provides functions to output documents in ASCII format. *)

open Sml_ng

(*s Pretty-printing of a document on stdout. [size] returns the size
    of a document in bytes. *)

val output_document : document -> unit

val size : document -> int

(*s These functions are exported to be re-used in module [Optim]. *)

val open_tag : tag -> unit
val close_tag : tag -> unit

(*s Dump of interpretations (for debugging purposes only). *)

val dump_char : out_channel -> decorated_char -> unit

val dump : out_channel -> interpretation -> unit


