(* ICFP Programming Contest 2001
 * Copyright (C) 2001 Jean-Christophe Filliatre *)

(*s SML/NG documents. A document is a list of item; an item is either
    a text of non-space characters, or a space character or a tag
    containing a list of item. *)

type color = 
  | Red | Green | Blue | Cyan | Magenta | Yellow | Black | White 
  | Any (* for root context *)

type tag = 
  | B
  | EM
  | I
  | PL
  | S
  | TT
  | U
  | Size of int (* 0..9 ; -1 for root context *)
  | Color of color

type white_space = SPC | TAB | CR | LF

type item = 
  | Text of string
  | Wspace of white_space
  | Tag of tag * item list

type document = item list

(*s Contexts. *)

type context = {
  b : bool;
  em : bool;
  i : bool;
  s : bool;
  tt : bool;
  u : int; (* 0..3 *)
  size : int; 
  color : color }

(*s The interpretation of a document is a stream of decorated chars
    (which pairs of chars and contexts). *)

type decorated_char = char * context

type interpretation = decorated_char Stream.t
